;####################################################
;##            ##
;##           ATtiny2313         ##
;##                  ##
;##           -----31.08.2010        ##
;####################################################

;------- 

       .include "tn2313def.inc"   ;   

       .list                      ;   

;-------   

       .def temp=R16              ;     

       .def loop=R17              ;   

       .equ KD=2500               ;    

;-------  

       .cseg                      ;    

       .org 0                     ;     
 
;------- STACK

       ldi temp, RAMEND           ;    STACK

	   out SPL, temp              ;    STACKa

;-------  /

       ldi temp, 0                ;   temp 0  
	   
	   out DDRD, temp             ;   D  
	   
	   ldi temp, 0xFF             ;   temp 0xFF
	   
	   out DDRB, temp             ;    
	   
	   out PORTB, temp            ;     
	   
	   out PORTD, temp            ;   
	   
;-------  

       ldi temp, 0x80             ;  
	   
	   out ACSR, temp      

;-------  1

       ldi temp, 0x05             ;  

	   out TCCR1B, temp           ;  

;-------   

main:  in temp, PIND              ;   D

       sbrs temp, 0               ;  0   D
	   
	   rjmp m1                    ;  0,    
	   
	   sbrs temp, 1               ;  1   D
	   
	   rjmp m2                    ;  0,    
	   
	   sbrs temp, 2               ;  2   D
	   
	   rjmp m3                    ;  0,    
	   
	   sbrs temp, 3               ;  3   D
	   
	   rjmp m4                    ;  0,    
	   
	   sbrs temp, 4               ;  4   D
	   
	   rjmp m5                    ;  0,    
	   
	   sbrs temp, 5               ;  5   D
	   
	   rjmp m6                    ;  0,    
	   
	   sbrs temp, 6               ;  6   D
	   
	   rjmp m7                    ;  0,    
	   
	   rjmp main                  ;    
	   
;-------   

m1:    ldi temp, 0xFE

       rcall Output
	   
	   ldi temp, 0xFD
	   
	   rcall Output
	   
	   ldi temp, 0xFB
	   
	   rcall Output
	   
	   ldi temp, 0xF7
	   
	   rcall Output
	   
	   ldi temp, 0xEF
	   
	   rcall Output
	   
	   ldi temp, 0xDF
	   
	   rcall Output
	   
	   ldi temp, 0xBF
	   
	   rcall Output
	   
	   ldi temp, 0x7F  
	   
	   rcall Output

	   ldi temp, 0xBF

	   rcall Output

	   ldi temp, 0xDF

       rcall Output

	   ldi temp, 0xEF

       rcall Output

	   ldi temp, 0xF7

	   rcall Output
	   
	   ldi  temp, 0xFB
	   
	   rcall Output

	   ldi temp, 0xFD

       rcall Output

	   ldi temp, 0xFE

	   rcall Output

	   ldi temp, 0xFF

	   rcall Output

	   rjmp main
	   
;-------  

m2:    ldi temp, 0xFC

       rcall Output
	   
	   ldi temp, 0xF3
	   
	   rcall Output
	   
	   ldi temp, 0xCF
	   
	   rcall Output
	   
	   ldi temp, 0x3F
	   
	   rcall Output
	   
	   ldi temp, 0xCF
	   
	   rcall Output 
	   
	   ldi temp, 0xF3
	   
	   rcall Output
	   
	   ldi temp, 0xFC
	   
	   rcall Output

	   ldi temp, 0xFF

	   rcall Output
	   
	   rjmp main
	   
;-------  

m3:    ldi temp, 0x01

       rcall Output
	   
	   ldi temp, 0x02
	   
	   rcall Output
	   
	   ldi temp, 0x04
	   
	   rcall Output
	   
	   ldi temp, 0x08
	   
	   rcall Output
	   
	   ldi temp, 0x10
	   
	   rcall Output
	   
	   ldi temp, 0x20
	   
	   rcall Output
	   
	   ldi temp, 0x40
	   
	   rcall Output
	   
	   ldi temp, 0x80
	   
	   rcall Output
	   
	   ldi temp, 0x40
	   
	   rcall Output
	   
	   ldi temp, 0x20
	   
	   rcall Output
	   
	   ldi temp, 0x10
	   
	   rcall Output
	   
	   ldi temp, 0x08
	   
	   rcall Output
	   
	   ldi temp, 0x04
	   
	   rcall Output
	   
	   ldi temp, 0x02
	   
	   rcall Output
	   
	   ldi temp, 0x01
	   
	   rcall Output

	   ldi temp, 0xFF

	   rcall Output
	   
	   rjmp main
	   
;-------  

m4:    ldi temp, 0x81

	   rcall Output
	   
	   ldi temp, 0x42
	   
	   rcall Output
	   
	   ldi temp, 0x24
	   
	   rcall Output
	   
	   ldi temp, 0x18
	   
	   rcall Output
	   
	   ldi temp, 0x24
	   
	   rcall Output
	   
	   ldi temp, 0x42
	   
	   rcall Output
	   
	   ldi temp, 0x81
	   
	   rcall Output

	   ldi temp, 0xFF

	   rcall Output
	   
	   rjmp main
	   
;-------  

m5:    ldi temp, 0x7E

       rcall Output

	   ldi temp, 0xBD

	   rcall Output

	   ldi temp, 0xDB

	   rcall Output

	   ldi temp, 0xE7

	   rcall Output

	   ldi temp, 0xDB

	   rcall Output

	   ldi temp, 0xBD

	   rcall Output

	   ldi temp, 0x7E

	   rcall Output

	   ldi temp, 0xFF

	   rcall Output

	   rjmp main

;-------  

m6:    ldi temp, 0x3C

       rcall Output

	   ldi temp, 0xC3

	   rcall Output

	   ldi temp, 0x3C

	   rcall Output

	   ldi temp, 0xC3

	   rcall Output

	   ldi temp, 0xF

	   rcall Output

	   ldi temp, 0xF0

	   rcall Output

	   ldi temp, 0

	   rcall Output

	   ldi temp, 0xFF

	   rcall Output

	   rjmp main

;-------  

m7:    ldi temp, 0x66

       rcall Output

	   ldi temp, 0x99

	   rcall Output

	   ldi temp, 0x55

	   rcall Output

	   ldi temp, 0xAA

	   rcall Output

	   ldi temp, 0xCC

	   rcall Output 

	   ldi temp, 0x33

	   rcall Output

	   ldi temp, 0xFF

	   rcall Output

	   rjmp main

;********************************************
;**      **
;**                           **
;********************************************

;-------    

Output:out PORTB, temp             ;    

;------- 

       push loop                   ;     STACK

	   ldi loop, 0                 ;     0

	   out TCNT1H, loop            ;      

	   out TCNT1L, loop            ;      

wt1:   in loop, TCNT1L             ;     

       cpi loop, low(KD)           ;    0D0

	   brlo wt1                    ;  ,                        

	   in loop, TCNT1H             ;     

	   cpi loop, high(KD)          ;    007

	   brlo wt1                    ;  ,  

	   pop loop                    ;     STACKa

	   ret                         ;    



	   


       

	   	   	            
